/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.records.TCoreLifetimeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreLifetime extends TableImpl<TCoreLifetimeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_lifetime</code>
     */
    public static final TCoreLifetime T_CORE_LIFETIME = new TCoreLifetime();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreLifetimeRecord> getRecordType() {
        return TCoreLifetimeRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_lifetime.lastchange</code>.
     */
    public final TableField<TCoreLifetimeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_lifetime.fk_element</code>. foreign key
     * to key_element
     */
    public final TableField<TCoreLifetimeRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER.nullable(false), this, "foreign key to key_element");

    /**
     * The column <code>common_dd.t_core_lifetime.valid_from</code>. valid from;
     * if null, date is unknown
     */
    public final TableField<TCoreLifetimeRecord, LocalDateTime> VALID_FROM = createField(DSL.name("valid_from"), SQLDataType.LOCALDATETIME(6), this, "valid from; if null, date is unknown");

    /**
     * The column <code>common_dd.t_core_lifetime.valid_until</code>. valid
     * until; if null, date is unknown (until now)
     */
    public final TableField<TCoreLifetimeRecord, LocalDateTime> VALID_UNTIL = createField(DSL.name("valid_until"), SQLDataType.LOCALDATETIME(6), this, "valid until; if null, date is unknown (until now)");

    private TCoreLifetime(Name alias, Table<TCoreLifetimeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreLifetime(Name alias, Table<TCoreLifetimeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_lifetime</code> table reference
     */
    public TCoreLifetime(String alias) {
        this(DSL.name(alias), T_CORE_LIFETIME);
    }

    /**
     * Create an aliased <code>common_dd.t_core_lifetime</code> table reference
     */
    public TCoreLifetime(Name alias) {
        this(alias, T_CORE_LIFETIME);
    }

    /**
     * Create a <code>common_dd.t_core_lifetime</code> table reference
     */
    public TCoreLifetime() {
        this(DSL.name("t_core_lifetime"), null);
    }

    public <O extends Record> TCoreLifetime(Table<O> path, ForeignKey<O, TCoreLifetimeRecord> childPath, InverseForeignKey<O, TCoreLifetimeRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_LIFETIME);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreLifetimePath extends TCoreLifetime implements Path<TCoreLifetimeRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreLifetimePath(Table<O> path, ForeignKey<O, TCoreLifetimeRecord> childPath, InverseForeignKey<O, TCoreLifetimeRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreLifetimePath(Name alias, Table<TCoreLifetimeRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreLifetimePath as(String alias) {
            return new TCoreLifetimePath(DSL.name(alias), this);
        }

        @Override
        public TCoreLifetimePath as(Name alias) {
            return new TCoreLifetimePath(alias, this);
        }

        @Override
        public TCoreLifetimePath as(Table<?> alias) {
            return new TCoreLifetimePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public UniqueKey<TCoreLifetimeRecord> getPrimaryKey() {
        return Keys.PK_CORE_LIFETIME;
    }

    @Override
    public List<ForeignKey<TCoreLifetimeRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_LIFETIME__FK_LIFETIME_ELEMENT);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_LIFETIME__FK_LIFETIME_ELEMENT, null);

        return _tCoreElementHierarchy;
    }

    @Override
    public TCoreLifetime as(String alias) {
        return new TCoreLifetime(DSL.name(alias), this);
    }

    @Override
    public TCoreLifetime as(Name alias) {
        return new TCoreLifetime(alias, this);
    }

    @Override
    public TCoreLifetime as(Table<?> alias) {
        return new TCoreLifetime(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLifetime rename(String name) {
        return new TCoreLifetime(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLifetime rename(Name name) {
        return new TCoreLifetime(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLifetime rename(Table<?> name) {
        return new TCoreLifetime(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLifetime where(Condition condition) {
        return new TCoreLifetime(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLifetime where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLifetime where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLifetime where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLifetime where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLifetime where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLifetime where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLifetime where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLifetime whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLifetime whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
